<h1 id="tabs">Tabs</h1>
<p>Tabs is a set of sections of content known as panels, of which only is displayed at a time, each with an associated button, or tab, used to display the panel.</p>
<p>Tabs conforms to the <a href="https://www.w3.org/WAI/ARIA/apg/patterns/tabpanel/">W3C WAI-ARIA authoring practices</a>.</p>
<h2 id="set-up">Set up</h2>
<p>First import the styles into your main SASS file, replacing <code>&lt;path-to-node_modules&gt;</code> with the path to the <em>node_modules</em> directory relative to the file:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/components/tabs/tabs';
</code></pre>
<p>Alternatively <em>ace.scss</em> includes all ACE component SASS files, so if using multiple ACE components it can be imported instead:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/ace';
</code></pre>
<p>A CSS file is also provided for convenience and is located at <code>&lt;path-to-node_modules&gt;/@potato/ace/components/tabs/ace-tabs.css</code>.</p>
<p>Then import the class into your JavaScript entry point:</p>
<pre><code class="language-js">import '&lt;path-to-node_modules&gt;/@potato/ace/components/tabs/tabs';
</code></pre>
<p>For convenience the ES6 class is exported as <code>Tabs</code> and the attribute names used by the class are exported as properties of <code>ATTRS</code>.</p>
<p>After the event <code>DOMContentLoaded</code> is fired on <code>document</code> an instance of Tabs is instantiated within each <code>&lt;ace-tabs&gt;</code> element and an ID <code>ace-tabs-&lt;n&gt;</code> is added for any instance without one, where <code>&lt;n&gt;</code> is a unique integer. Once instantiation is complete a custom event <code>ace-tabs-ready</code> is dispatched to <code>window</code>. See the <strong>Custom events</strong> section below for more details.</p>
<p>The buttons that display the panels, known as tabs, must be nested within a tablist element with attribute <code>ace-tabs-tablist</code>. If no descendant has this attribute then the first child <code>&lt;div&gt;</code> will be used and given this attribute. It is strongly recommended that this tablist element be provided with an accessible label using <code>aria-label</code> or <code>aria-labelledby</code>. The word &quot;tablist&quot; should not be included in the label as Tabs has <code>role=&quot;tablist&quot;</code> which is read out by screen readers.</p>
<p>Tabs must also have the same number of panel elements as tabs. Tabs will use any descendant with attribute <code>ace-tabs-panel</code>. If no descendants have this attribute then all child elements except the first, which should be the tablist, will be used and given this attribute.</p>
<h2 id="usage">Usage</h2>
<p>The displayed panel of Tabs can be changed using the tab buttons, keyboard keys or custom events; or by changing the value of its attribute <code>ace-tabs-selected-tab</code> to the panel's number, e.g. <code>2</code> will display the second panel and <code>3</code> the third. This attribute can be set before instantiation to display a specific panel on page load, but if omitted Tabs will add it and set its value to <code>1</code> thereby displaying the first panel. The attribute's value is also dynamically updated when the displayed panel is changed using the other methods.</p>
<p>When a tab is focused, pressing <kbd>←</kbd> or <kbd>→</kbd> (<kbd>↑</kbd> or <kbd>↓</kbd> for vertical Tabs) will select the previous or next tab in the list respectively, while pressing <kbd>Home</kbd> or <kbd>End</kbd> will select the first or last tab respectively.</p>
<p>Tabs can be added or removed dynamically as long as custom event <code>ace-tabs-update</code> is dispatched to the Tabs component afterwards.</p>
<p>Giving the Tabs the attribute <code>ace-tabs-infinite</code> allows infinite rotation through panels, where pressing <kbd>←</kbd> (or <kbd>↑</kbd> for vertical Tabs) with the first panel displayed will display the last, and pressing <kbd>→</kbd> (or <kbd>↓</kbd> in vertical Tabs) with the last panel displayed will display the first. Giving the Tabs the attribute <code>ace-tabs-vertical</code> stacks the tabs vertically and makes <kbd>↑</kbd> and <kbd>↓</kbd> change the displayed panel, rather than <kbd>←</kbd> or <kbd>→</kbd>. These two attributes are observed attributes that can be added or removed to dynamically enable or disable their respective behaviour.</p>
<p>Tabs can be given the attribute <code>ace-tabs-manual</code> which will cause the arrow keys to change the focused tab without changing the displayed panel. For these Tabs the focused tab's corresponding panel can be displayed manually by pressing <kbd>Space</kbd> or <kbd>Enter</kbd>.</p>
<p>Tabs with the attribute <code>ace-tabs-deep-linked</code> are deep-linked meaning that whenever the displayed panel changes, the page URL is dynamically updated to include a search parameter with key and value equal to the Tabs ID and the displayed panel respectively. Deep linking works with multiple Tabs components, each adding a search parameter to the URL. When a page is loaded if the URL contains a search parameter for a deep-linked Tabs component, the panel whose number matched the search parameter value is displayed. This is a useful feature for sharing pages with specific tabs diplayed.</p>
<h2 id="styles">Styles</h2>
<p>The following SASS is applied to Tabs. The SASS variables use <code>!default</code> so can also be easily overridden by users. SASS variables used that are not defined here are defined in <em>&lt;path-to-node_modules&gt;/@potato/ace/common/constants.scss</em>.</p>
<pre><code class="language-scss">@import '../../common/constants';


// VARIABLES
$ace-tabs-selected-tab-border-color: $ace-color-selected !default;
$ace-tabs-selected-tab-border-width: 4px !default;
$ace-tabs-tab-bg-color: transparent !default;
$ace-tabs-tab-padding-horizontal: $ace-spacing-4 !default;
$ace-tabs-tab-padding-vertical: $ace-spacing-2 !default;
$ace-tabs-tab-padding: $ace-spacing-3 !default;
$ace-tabs-tab-focus-and-hover-bg-color: $ace-color-hover !default;
$ace-tabs-tablist-margin: $ace-spacing-2 !default;
$ace-tabs-panel-padding: 16px !default;


// STYLES
[ace-tabs-tablist] {
	display: flex;
	overflow: auto hidden;
	white-space: nowrap;
}

[ace-tabs-tab] {
	background-color: $ace-tabs-tab-bg-color;
	border-color: transparent;
	border-style: solid;
	border-width: 0 0 $ace-tabs-selected-tab-border-width 0;
	cursor: pointer;
	padding: $ace-tabs-tab-padding-vertical $ace-tabs-tab-padding-horizontal;

	&amp;:focus,
	&amp;:hover {
		background-color: $ace-tabs-tab-focus-and-hover-bg-color;
	}

	&amp;:focus {
		outline: none;
	}
}

[ace-tabs-tab-selected] {
	border-color: $ace-tabs-selected-tab-border-color;
}

[ace-tabs-panel] {
	padding: $ace-tabs-panel-padding;

	&amp;:not([ace-tabs-panel-visible]) {
		display: none;
	}
}


// Vertical Tabs
[ace-tabs-vertical] {
	display: flex;

	[ace-tabs-tablist] {
		flex-direction: column;
		overflow: hidden auto;
	}

	[ace-tabs-tab] {
		border-width: 0 $ace-tabs-selected-tab-border-width 0 0;
	}
}
</code></pre>
<h2 id="custom-events">Custom events</h2>
<p>Tabs uses the following custom events, the names of which are available in its exported <code>EVENTS</code> object, similar to <code>ATTRS</code>, so they may be imported into other modules.</p>
<h3 id="dispatched-events">Dispatched events</h3>
<p>The following events are dispatched to <code>window</code> by Tabs.</p>
<h4 id="ready">Ready</h4>
<p><code>ace-tabs-ready</code></p>
<p>This event is dispatched when Tabs finishes initialising just after page load, and after dynamically added descendants are initialised in response to the <code>ace-tabs-update</code> custom event being dispatched. The event name is available as <code>EVENTS.OUT.READY</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Tabs [string]
}
</code></pre>
<h4 id="selected-tab-changed">Selected tab changed</h4>
<p><code>ace-tabs-selected-tab-changed</code></p>
<p>This event is dispatched when the selected tab changes. Listening for this event can be useful for timing and triggering animations on Tabs.
The event name is available as <code>EVENTS.OUT.SELECTED_TAB_CHANGED</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Tabs [string]
	'currentlySelectedTab': {
		'id': // Currently selected tab ID [string]
		'number': // Currently selected tab number [number]
	},
	'previouslySelectedTab': {
		'id': // Previously selected tab ID [string]
		'number': // Previously selected tab number [number]
	}
}
</code></pre>
<h3 id="listened-for-events">Listened for events</h3>
<p>Tabs listens for the following events that should be dispatched to <code>window</code>.</p>
<h4 id="previous-tab">Previous tab</h4>
<p><code>ace-tabs-set-prev-tab</code></p>
<p>This event should be dispatched to select the previous tab, or the last tab if the first tab is selected and Tabs has attribute <code>ace-tabs-infinite</code>. The event name is available as <code>EVENTS.IN.SET_PREV_TAB</code> and its <code>detail</code> property should be composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of target Tabs [string]
}
</code></pre>
<h4 id="next-tab">Next tab</h4>
<p><code>ace-tabs-set-next-tab</code></p>
<p>This event should be dispatched to select the next tab, or the first tab if the last tab is selected and Tabs has attribute <code>ace-tabs-infinite</code>. The event name is available as <code>EVENTS.IN.SET_NEXT_TAB</code> and its <code>detail</code> property should be composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of target Tabs [string]
}
</code></pre>
<h4 id="update-tabs">Update tabs</h4>
<p><code>ace-tabs-update</code></p>
<p>This event should be dispatched when tabs are added or removed and causes Tabs to initialise them and then dispatch the <code>ace-tabs-ready</code> event.tgabs The event name is available as <code>EVENTS.IN.UPDATE</code> and its <code>detail</code> property should be composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of target Tabs [string]
}
</code></pre>
<h2 id="examples">Examples</h2>
<p>Each example contains a live demo and the HTML code that produced it. The code shown may differ slightly to that rendered for the demo as some components may alter their HTML when they initialise.</p>
<h3 id="simple-tabs">Simple Tabs</h3>
<p>The default Tabs with three tabs.</p>
<div class="example-block"><ace-tabs>
	<div aria-label="Basic Tabs">
		<button>Tab 1</button>
		<button>Tab 2</button>
		<button>Tab 3</button>
	</div>
	<div>
		<h3>Panel 1 heading</h3>
		<p>Panel 1 content.</p>
		<img src="/img/logo.svg" height="100px" alt="Potato logo" />
	</div>
	<div>
		<h3>Panel 2 heading</h3>
		<p>Panel 2 content.</p>
		<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone" />
	</div>
	<div>
		<h3>Panel 3 heading</h3>
		<p>Panel 3 content.</p>
		<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles" />
	</div>
</ace-tabs>
</div>
<pre><code class="language-html">&lt;ace-tabs&gt;
	&lt;div aria-label=&quot;Basic Tabs&quot;&gt;
		&lt;button&gt;Tab 1&lt;/button&gt;
		&lt;button&gt;Tab 2&lt;/button&gt;
		&lt;button&gt;Tab 3&lt;/button&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 1 heading&lt;/h3&gt;
		&lt;p&gt;Panel 1 content.&lt;/p&gt;
		&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 2 heading&lt;/h3&gt;
		&lt;p&gt;Panel 2 content.&lt;/p&gt;
		&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 3 heading&lt;/h3&gt;
		&lt;p&gt;Panel 3 content.&lt;/p&gt;
		&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot; /&gt;
	&lt;/div&gt;
&lt;/ace-tabs&gt;
</code></pre>
<h3 id="infinite-rotation-tabs">Infinite rotation Tabs</h3>
<p>Tabs with infinite rotation.</p>
<div class="example-block"><ace-tabs id="ace-infinite-tabs" ace-tabs-infinite ace-tabs-selected-tab="2">
	<div aria-label="Tabs with infinite scroll">
		<button>Tab 1</button>
		<button>Tab 2</button>
		<button>Tab 3</button>
	</div>
	<div>
		<h3>Panel 1 heading</h3>
		<p>Panel 1 content.</p>
		<img src="/img/logo.svg" height="100px" alt="Potato logo" />
	</div>
	<div>
		<h3>Panel 2 heading</h3>
		<p>Panel 2 content.</p>
		<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone" />
	</div>
	<div>
		<h3>Panel 3 heading</h3>
		<p>Panel 3 content.</p>
		<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles" />
	</div>
</ace-tabs>
</div>
<pre><code class="language-html">&lt;ace-tabs id=&quot;ace-infinite-tabs&quot; ace-tabs-infinite ace-tabs-selected-tab=&quot;2&quot;&gt;
	&lt;div aria-label=&quot;Tabs with infinite scroll&quot;&gt;
		&lt;button&gt;Tab 1&lt;/button&gt;
		&lt;button&gt;Tab 2&lt;/button&gt;
		&lt;button&gt;Tab 3&lt;/button&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 1 heading&lt;/h3&gt;
		&lt;p&gt;Panel 1 content.&lt;/p&gt;
		&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 2 heading&lt;/h3&gt;
		&lt;p&gt;Panel 2 content.&lt;/p&gt;
		&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 3 heading&lt;/h3&gt;
		&lt;p&gt;Panel 3 content.&lt;/p&gt;
		&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot; /&gt;
	&lt;/div&gt;
&lt;/ace-tabs&gt;
</code></pre>
<h3 id="vertical-tabs">Vertical Tabs</h3>
<p>Tabs with vertically stacked tabs.</p>
<div class="example-block"><ace-tabs id="ace-vertical-tabs" ace-tabs-vertical>
	<div aria-label="Tabs with vertically-oriented tablist">
		<button>Tab 1</button>
		<button>Tab 2</button>
		<button>Tab 3</button>
	</div>
	<div>
		<h3>Panel 1 heading</h3>
		<p>Panel 1 content.</p>
		<img src="/img/logo.svg" height="100px" alt="Potato logo" />
	</div>
	<div>
		<h3>Panel 2 heading</h3>
		<p>Panel 2 content.</p>
		<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone" />
	</div>
	<div>
		<h3>Panel 3 heading</h3>
		<p>Panel 3 content.</p>
		<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles" />
	</div>
</ace-tabs>
</div>
<pre><code class="language-html">&lt;ace-tabs id=&quot;ace-vertical-tabs&quot; ace-tabs-vertical&gt;
	&lt;div aria-label=&quot;Tabs with vertically-oriented tablist&quot;&gt;
		&lt;button&gt;Tab 1&lt;/button&gt;
		&lt;button&gt;Tab 2&lt;/button&gt;
		&lt;button&gt;Tab 3&lt;/button&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 1 heading&lt;/h3&gt;
		&lt;p&gt;Panel 1 content.&lt;/p&gt;
		&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 2 heading&lt;/h3&gt;
		&lt;p&gt;Panel 2 content.&lt;/p&gt;
		&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 3 heading&lt;/h3&gt;
		&lt;p&gt;Panel 3 content.&lt;/p&gt;
		&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot; /&gt;
	&lt;/div&gt;
&lt;/ace-tabs&gt;
</code></pre>
<h3 id="manually-displayed-tabs">Manually displayed Tabs</h3>
<p>Tabs with panels that are displayed by pressing <kbd>Space</kbd> or <kbd>Enter</kbd> when their corresponding tab is focused.</p>
<div class="example-block"><ace-tabs id="ace-manual-tabs" ace-tabs-manual>
	<div aria-label="Tabs with manual activation">
		<button>Tab 1</button>
		<button>Tab 2</button>
		<button>Tab 3</button>
	</div>
	<div>
		<h3>Panel 1 heading</h3>
		<p>Panel 1 content.</p>
		<img src="/img/logo.svg" height="100px" alt="Potato logo" />
	</div>
	<div>
		<h3>Panel 2 heading</h3>
		<p>Panel 2 content.</p>
		<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone" />
	</div>
	<div>
		<h3>Panel 3 heading</h3>
		<p>Panel 3 content.</p>
		<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles" />
	</div>
</ace-tabs>
</div>
<pre><code class="language-html">&lt;ace-tabs id=&quot;ace-manual-tabs&quot; ace-tabs-manual&gt;
	&lt;div aria-label=&quot;Tabs with manual activation&quot;&gt;
		&lt;button&gt;Tab 1&lt;/button&gt;
		&lt;button&gt;Tab 2&lt;/button&gt;
		&lt;button&gt;Tab 3&lt;/button&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 1 heading&lt;/h3&gt;
		&lt;p&gt;Panel 1 content.&lt;/p&gt;
		&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 2 heading&lt;/h3&gt;
		&lt;p&gt;Panel 2 content.&lt;/p&gt;
		&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 3 heading&lt;/h3&gt;
		&lt;p&gt;Panel 3 content.&lt;/p&gt;
		&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot; /&gt;
	&lt;/div&gt;
&lt;/ace-tabs&gt;
</code></pre>
<h3 id="deep-linked-tabs">Deep-linked Tabs</h3>
<p>Two Tabs components with deep linking enabled.</p>
<div class="example-block"><h3>Deep-linked</h3>
<ace-tabs id="ace-deep-linked-tabs-1" ace-tabs-deep-linked>
	<div aria-label="Deep-linked Tabs">
		<button>Tab 1</button>
		<button>Tab 2</button>
		<button>Tab 3</button>
	</div>
	<div>
		<h3>Panel 1 heading</h3>
		<p>Panel 1 content.</p>
		<img src="/img/logo.svg" height="100px" alt="Potato logo" />
	</div>
	<div>
		<h3>Panel 2 heading</h3>
		<p>Panel 2 content.</p>
		<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone" />
	</div>
	<div>
		<h3>Panel 3 heading</h3>
		<p>Panel 3 content.</p>
		<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles" />
	</div>
</ace-tabs>
<hr>
<h3>Deep-linked vertical Tabs with initially set tab 2</h3>
<ace-tabs id="ace-deep-linked-tabs-2" ace-tabs-deep-linked ace-tabs-vertical ace-tabs-selected-tab="2">
	<div aria-label="Deep-linked, vertical Tabs with initially set tab">
		<button>Tab 1</button>
		<button>Tab 2</button>
		<button>Tab 3</button>
	</div>
	<div>
		<h3>Panel 1 heading</h3>
		<p>Panel 1 content.</p>
		<img src="/img/logo.svg" height="100px" alt="Potato logo" />
	</div>
	<div>
		<h3>Panel 2 heading</h3>
		<p>Panel 2 content.</p>
		<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone" />
	</div>
	<div>
		<h3>Panel 3 heading</h3>
		<p>Panel 3 content.</p>
		<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles" />
	</div>
</ace-tabs>
</div>
<pre><code class="language-html">&lt;h3&gt;Deep-linked&lt;/h3&gt;

&lt;ace-tabs id=&quot;ace-deep-linked-tabs-1&quot; ace-tabs-deep-linked&gt;
	&lt;div aria-label=&quot;Deep-linked Tabs&quot;&gt;
		&lt;button&gt;Tab 1&lt;/button&gt;
		&lt;button&gt;Tab 2&lt;/button&gt;
		&lt;button&gt;Tab 3&lt;/button&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 1 heading&lt;/h3&gt;
		&lt;p&gt;Panel 1 content.&lt;/p&gt;
		&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 2 heading&lt;/h3&gt;
		&lt;p&gt;Panel 2 content.&lt;/p&gt;
		&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 3 heading&lt;/h3&gt;
		&lt;p&gt;Panel 3 content.&lt;/p&gt;
		&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot; /&gt;
	&lt;/div&gt;
&lt;/ace-tabs&gt;

&lt;hr&gt;

&lt;h3&gt;Deep-linked vertical Tabs with initially set tab 2&lt;/h3&gt;

&lt;ace-tabs id=&quot;ace-deep-linked-tabs-2&quot; ace-tabs-deep-linked ace-tabs-vertical ace-tabs-selected-tab=&quot;2&quot;&gt;
	&lt;div aria-label=&quot;Deep-linked, vertical Tabs with initially set tab&quot;&gt;
		&lt;button&gt;Tab 1&lt;/button&gt;
		&lt;button&gt;Tab 2&lt;/button&gt;
		&lt;button&gt;Tab 3&lt;/button&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 1 heading&lt;/h3&gt;
		&lt;p&gt;Panel 1 content.&lt;/p&gt;
		&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 2 heading&lt;/h3&gt;
		&lt;p&gt;Panel 2 content.&lt;/p&gt;
		&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 3 heading&lt;/h3&gt;
		&lt;p&gt;Panel 3 content.&lt;/p&gt;
		&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot; /&gt;
	&lt;/div&gt;
&lt;/ace-tabs&gt;
</code></pre>
<h3 id="tabs-controlled-using-custom-events">Tabs controlled using custom events</h3>
<p>The buttons in this example dispatch the <code>ace-tabs-set-prev-tab</code>, <code>ace-tabs-set-next-tab</code> and <code>ace-tabs-update-tabs</code> custom events on the Tabs. The JavaScript used by this example is shown below.</p>
<div class="example-block"><p>These buttons dispatch custom events</p>
<button id="prev-tab-btn">Prev tab</button>
<button id="next-tab-btn">Next tab</button>
<button id="add-tab-btn">Add tab to end</button>
<button id="remove-tab-btn">Remove last tab</button>
<hr>
<ace-tabs id="ace-custom-events-tabs">
	<div aria-label="Tabs that repond to custom events">
		<button>Tab 1</button>
		<button>Tab 2</button>
		<button>Tab 3</button>
	</div>
	<div>
		<h3>Panel 1 heading</h3>
		<p>Panel 1 content.</p>
		<img src="/img/logo.svg" height="100px" alt="Potato logo" />
	</div>
	<div>
		<h3>Panel 2 heading</h3>
		<p>Panel 2 content.</p>
		<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone" />
	</div>
	<div>
		<h3>Panel 3 heading</h3>
		<p>Panel 3 content.</p>
		<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles" />
	</div>
</ace-tabs>
</div>
<pre><code class="language-html">&lt;p&gt;These buttons dispatch custom events&lt;/p&gt;
&lt;button id=&quot;prev-tab-btn&quot;&gt;Prev tab&lt;/button&gt;
&lt;button id=&quot;next-tab-btn&quot;&gt;Next tab&lt;/button&gt;
&lt;button id=&quot;add-tab-btn&quot;&gt;Add tab to end&lt;/button&gt;
&lt;button id=&quot;remove-tab-btn&quot;&gt;Remove last tab&lt;/button&gt;

&lt;hr&gt;

&lt;ace-tabs id=&quot;ace-custom-events-tabs&quot;&gt;
	&lt;div aria-label=&quot;Tabs that repond to custom events&quot;&gt;
		&lt;button&gt;Tab 1&lt;/button&gt;
		&lt;button&gt;Tab 2&lt;/button&gt;
		&lt;button&gt;Tab 3&lt;/button&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 1 heading&lt;/h3&gt;
		&lt;p&gt;Panel 1 content.&lt;/p&gt;
		&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 2 heading&lt;/h3&gt;
		&lt;p&gt;Panel 2 content.&lt;/p&gt;
		&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot; /&gt;
	&lt;/div&gt;
	&lt;div&gt;
		&lt;h3&gt;Panel 3 heading&lt;/h3&gt;
		&lt;p&gt;Panel 3 content.&lt;/p&gt;
		&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot; /&gt;
	&lt;/div&gt;
&lt;/ace-tabs&gt;
</code></pre>
<pre><code class="language-js">import { ATTRS, EVENTS } from '/ace/components/tabs/tabs.js';

document.addEventListener('DOMContentLoaded', () =&gt; {
	const TABS_ID = 'ace-custom-events-tabs';
	const tabsEl = document.getElementById(TABS_ID);
	const tablistEl = tabsEl.querySelector(`[${ATTRS.TABLIST}]`);

	const addTab = () =&gt; {
		const tabNumber = tablistEl.children.length + 1;
		const newTab = document.createElement('button');
		newTab.textContent = `Tab ${tabNumber}`;
		tablistEl.appendChild(newTab);

		const heading = document.createElement('h3');
		heading.textContent = `Panel ${tabNumber}`;
		const p = document.createElement('p');
		p.textContent = `This tab was added dynamically, after this Tabs component was initialised`;
		const newPanel = document.createElement('div');
		newPanel.setAttribute(ATTRS.PANEL, '');
		newPanel.appendChild(heading);
		newPanel.appendChild(p);
		tabsEl.appendChild(newPanel);
	};

	const removeTab = () =&gt; {
		tablistEl.removeChild(tablistEl.lastElementChild);
		tabsEl.removeChild(tabsEl.lastElementChild);
	};

	window.addEventListener('click', (e) =&gt; {
		const targetId = e.target.id;
		switch (targetId) {
			case 'prev-tab-btn':
			case 'next-tab-btn': {
				const event = EVENTS.IN[`SET_${targetId === 'prev-tab-btn' ? 'PREV' : 'NEXT'}_TAB`];
				window.dispatchEvent(new CustomEvent(
					event,
					{'detail': {'id': TABS_ID}},
				));
				break;
			}
			case 'add-tab-btn':
			case 'remove-tab-btn':
				if (targetId === 'add-tab-btn') {
					addTab();
				} else {
					removeTab();
				}
				window.dispatchEvent(new CustomEvent(
					EVENTS.IN.UPDATE,
					{'detail': {'id': TABS_ID}},
				));
				break;
		}
	});
});
</code></pre>
<h3 id="styled-tabs">Styled Tabs</h3>
<p>An example of how Tabs can be styled, with the applied CSS shown below.</p>
<div class="example-block"><ace-tabs class="styled-tabs">
	<div aria-label="Basic Tabs" class="styled-tabs__tablist">
		<button class="styled-tabs__tab">Tab 1</button>
		<button class="styled-tabs__tab">Tab 2</button>
		<button class="styled-tabs__tab">Tab 3</button>
	</div>
	<div class="styled-tabs__panel">
		<h3>Panel 1 heading</h3>
		<p>Panel 1 content.</p>
		<img src="/img/logo.svg" height="100px" alt="Potato logo" />
	</div>
	<div class="styled-tabs__panel">
		<h3>Panel 2 heading</h3>
		<p>Panel 2 content.</p>
		<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone" />
	</div>
	<div class="styled-tabs__panel">
		<h3>Panel 3 heading</h3>
		<p>Panel 3 content.</p>
		<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles" />
	</div>
</ace-tabs>
</div>
<pre><code class="language-html">&lt;ace-tabs class=&quot;styled-tabs&quot;&gt;
	&lt;div aria-label=&quot;Basic Tabs&quot; class=&quot;styled-tabs__tablist&quot;&gt;
		&lt;button class=&quot;styled-tabs__tab&quot;&gt;Tab 1&lt;/button&gt;
		&lt;button class=&quot;styled-tabs__tab&quot;&gt;Tab 2&lt;/button&gt;
		&lt;button class=&quot;styled-tabs__tab&quot;&gt;Tab 3&lt;/button&gt;
	&lt;/div&gt;
	&lt;div class=&quot;styled-tabs__panel&quot;&gt;
		&lt;h3&gt;Panel 1 heading&lt;/h3&gt;
		&lt;p&gt;Panel 1 content.&lt;/p&gt;
		&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot; /&gt;
	&lt;/div&gt;
	&lt;div class=&quot;styled-tabs__panel&quot;&gt;
		&lt;h3&gt;Panel 2 heading&lt;/h3&gt;
		&lt;p&gt;Panel 2 content.&lt;/p&gt;
		&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot; /&gt;
	&lt;/div&gt;
	&lt;div class=&quot;styled-tabs__panel&quot;&gt;
		&lt;h3&gt;Panel 3 heading&lt;/h3&gt;
		&lt;p&gt;Panel 3 content.&lt;/p&gt;
		&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot; /&gt;
	&lt;/div&gt;
&lt;/ace-tabs&gt;
</code></pre>
<pre><code class="language-scss">.styled-tabs {
	display: block;
	max-width: 500px;

	&amp;__tab,
	&amp;__panel {
		font-family: 'Roboto', sans-serif;
		font-size: 14px;
	}

	&amp;__tab {
		border-color: #41354d;
		flex-grow: 1;

		&amp;:focus,
		&amp;:hover {
			background: #41354d;
			color: #fff;
		}
	}

	&amp;__panel {
		border: 4px solid #41354d;
		border-top: none;
	}

	[ace-tabs-tab-selected] {
		background: #41354d;
		border-color: #41354d;
		color: #fff;

		&amp;:focus {
			border-color: #00bed0;
		}
	}
}

</code></pre>
